]> git.phdru.name Git - dotfiles.git/blob - .shellrc
.shellrc: Get remote for cdremote from the current branch
[dotfiles.git] / .shellrc
1 #
2 # $HOME/.shellrc
3 #
4
5 # ~/.bashrc: executed by bash(1) for non-login shells.
6 # see /usr/share/doc/bash/examples/startup-files (in the package bash-doc)
7 # for examples
8
9 # If not running interactively, don't do anything
10 case $- in
11     *i*) ;;
12       *) return ;;
13 esac
14
15 # Stop if non-interactive shell
16 [ -z "$PS1" ] && return
17
18 if test -n "$BASH_VERSION"; then
19    # append to the history file, don't overwrite it
20    shopt -s histappend
21
22    # check the window size after each command and, if necessary,
23    # update the values of LINES and COLUMNS.
24    shopt -s checkwinsize
25
26    # If set, the pattern "**" used in a pathname expansion context will
27    # match all files and zero or more directories and subdirectories.
28    #shopt -s globstar
29 fi
30
31
32 #if [ -x /usr/bin/dircolors ]; then
33 #   # I don't like these aliases - they work only in command line
34 #   # but not in scripts I run from command line.
35 #   # Color parameters must be passed via environment.
36 #   # So instead I put them in shell scripts in ~/bin.
37 #   alias ls='ls --color=auto'
38 #   alias dir='dir --color=auto'
39 #   alias vdir='vdir --color=auto'
40 #
41 #   alias grep='grep --color=auto'
42 #   alias fgrep='fgrep --color=auto'
43 #   alias egrep='egrep --color=auto'
44 #
45 #   alias dmesg='dmesg --human'
46 #fi
47
48
49 case "$HOME" in
50    /home/*)
51       if [ -L /home ]; then
52          START_DIR="`pwd`" &&
53          cd "$HOME" &&
54          HOME="`pwd`" &&
55          cd "$START_DIR"
56       fi
57    ;;
58 esac
59
60
61 OPS1="$OPS1\\$"
62 PS1="$OPS1 "
63
64
65 if test -n "$BASH_VERSION"; then
66    [ "`type -t ls`" = alias ] && unalias ls
67    [ "`type -t ll`" = alias ] && unalias ll
68    [ "`type -t mc`" = alias ] && unalias mc
69
70    back() { cd - "$@"; }
71    functions() { typeset -f "$@"; }
72    j() { jobs; }
73
74    if [ -z "$BASH_COMPLETION_COMPAT_DIR" ]; then
75       if [ "$SHELL" = /bin/bash ]; then
76          if [ -f /etc/bash_completion ]; then
77             . /etc/bash_completion
78          elif [ -d /etc/bash_completion.d ]; then
79             . /etc/bash_completion.d/*
80          fi
81       elif [ "$SHELL" = /usr/local/bin/bash ]; then
82          if [ -d /usr/local/etc/bash_completion.d ]; then
83             . /usr/local/etc/bash_completion.d/*
84          fi
85       else
86          echo "Unknown OS type, cannot source bash_completion" >&2
87       fi
88    fi
89
90    has_completion() { return 0; }
91    if [ "$SHELL" = /bin/bash ]; then
92       if [ -d /etc/bash_completion.d -o -d /usr/share/bash-completion/completions ]; then
93          has_completion() { [ -r /etc/bash_completion.d/$1 -o -r /usr/share/bash-completion/completions/$1 ]; }
94       fi
95    elif [ "$SHELL" = /usr/local/bin/bash ]; then
96       if [ -d /usr/local/etc/bash_completion.d ]; then
97          has_completion() { [ -r /usr/local/etc/bash_completion.d/$1 ]; }
98       fi
99    fi
100
101    for cmd in builtin cgmem_nice command dbus-launch exec \
102       killall man nice nohup pidof pidOf KillAll pgrep pkill psg pswg su sudo \
103       time whence whereis which xargs; do
104          ! has_completion $cmd && complete -o default -A command $cmd
105    done
106
107    for cmd in dig host mtr nslookup nc netcat nmap p ping ping6 socat \
108       telnet t tt \
109       tcptraceroute tcptraceroute6 tracert tracert6 traceroute traceroute6 \
110       whois wget wget-m wget-wrapper ww; do
111          ! has_completion $cmd && complete -A hostname $cmd
112    done
113
114    for cmd in distribute ftp lftp r rsync \
115       s scp ssh smbclient tcpdump tshark wireshark; do
116          ! has_completion $cmd && complete -o default -A hostname $cmd;
117    done
118
119    delegate_completion() {
120       local prog programs
121       prog=$1
122       if has_completion $prog; then
123          shift
124          programs="$@"
125          eval "_${prog}_completion_loader() {
126             _completion_loader $prog
127             complete -F _$prog $programs
128             unset _${prog}_completion_loader
129             return 124
130          }"
131          complete -F _${prog}_completion_loader $programs
132       fi
133    }
134
135    delegate_completion make m
136    delegate_completion ping p
137    delegate_completion rsync r
138    delegate_completion ssh s
139    delegate_completion wget wget-m wget-wrapper ww
140
141    unset has_completion delegate_completion
142
143    complete -A job bg fg j jobs wait
144    complete -A variable -A function unset
145
146    if [ -d "$HOME/lib/config" ]; then
147       complete -W "`cd \"$HOME/lib/config\" && echo *`" include
148    fi
149    complete -W "`echo $BROWSER | sed 's/:/ /g'`" start-browser
150
151    #if type -p pip >/dev/null 2>&1; then
152    #   eval "`pip completion --bash`"
153    #   rm -rf /tmp/pip_build_"$USER"
154    #fi
155
156    #if which pyenv >/dev/null 2>&1; then
157    #   eval "`pyenv init -`"
158    #   eval "`pyenv virtualenv-init -`"
159    #fi
160
161    source virtualenvwrapper_lazy.sh 2>/dev/null
162
163    if [ -n "$VIRTUAL_ENV" ] && ! type deactivate >/dev/null 2>&1; then
164       . "$VIRTUAL_ENV/bin/activate"
165    fi
166
167 elif test -n "$KSH_VERSION" -o -n "$FCEDIT"; then
168    back() { cd - "$@"; }
169    j() { jobs; }
170 fi
171
172
173 # clear screen and history, logout
174 chlo() { clear; cd; >$HISTFILE; unset HISTFILE; history -c; logout || exit; }
175
176
177 if test -x /usr/bin/git >/dev/null 2>&1; then
178    # chdir to a remote's directory (if the remote is on the local FS)
179    cdremote() {
180       if [ -z "$1" ]; then
181          branch="`git rev-parse --abbrev-ref HEAD`"
182          remote="`git config --get branch.$branch.remote`"
183       elif [ -n "$2" ]; then
184          echo "Usage: cdremote [remote_name]" >&2
185          return 1
186       else
187          remote="$1"
188       fi
189
190       if [ -z "$remote" ]; then
191          echo "Cannot find remote for branch $branch" >&2
192          echo "Usage: cdremote [remote_name]" >&2
193          return 1
194       fi
195
196       cd "`git config --get remote.$remote.url`"
197    }
198
199    if test -n "$BASH_VERSION"; then
200       # completion for aliases in global .gitconfig
201
202       # fixup rbi rbia rbiap rbip - do refs name completion
203       _git_fixup() { __gitcomp_nl "$(__git_refs)" ; }
204       _git_rbi() { __gitcomp_nl "$(__git_refs)" ; }
205       _git_rbia() { __gitcomp_nl "$(__git_refs)" ; }
206       _git_rbiap() { __gitcomp_nl "$(__git_refs)" ; }
207       _git_rbip() { __gitcomp_nl "$(__git_refs)" ; }
208       #
209       # push-to-all-remotes - do branch name completion
210       _git_push_to_all_remotes() { __gitcomp_nl "$(__git_heads)" ; }
211
212       # list remotes with URLs matching a regexp
213       _list_remotes() {
214          if [ -z "$1" -o -n "$2" ]; then
215             echo "Usage: _list_remotes remote_regexp" >&2
216             return 1
217          fi
218          GIT_REMOTES=""
219          local remote
220          for remote in `git remote`; do
221             if git config --get remote.$remote.url | grep -q "$1"; then
222                GIT_REMOTES="$GIT_REMOTES $remote"
223             fi
224          done
225       }
226
227       # completion for cdremote and git-open - list remotes with a pattern
228       _list_remotes_completion() {
229          local cur="${COMP_WORDS[COMP_CWORD]}";
230          _list_remotes "$1"
231          COMPREPLY=(`compgen -W "$GIT_REMOTES" -- "$cur"`)
232          unset GIT_REMOTES
233       }
234
235       # completion for cdremote - list remotes with directories as URLs
236       _cdremote_complete() {
237          _list_remotes_completion '^\(/\|\.\./\)' # (/ or ../ at the beginning)
238       }
239
240       complete -F _cdremote_complete cdremote
241
242       # completion for git-open - list remotes with http(s) URLs
243       _git_open() {
244          _list_remotes_completion '^http\(s\)\?://'
245       }
246
247       complete -F _git_open git-open
248    fi
249 fi
250
251
252 include() {
253    cfg="$1"
254    if [ -f "./$cfg" -a -r "./$cfg" ]; then
255       echo "Reading config file \`$cfg'" 1>&2
256       . "./$cfg"
257    elif [ -f "$HOME/lib/config/$cfg" -a -r "$HOME/lib/config/$cfg" ]; then
258       echo "Reading config file \`$HOME/lib/config/$cfg'" 1>&2
259       . "$HOME/lib/config/$cfg"
260    else
261       echo "Cannot find config file \`$cfg'" 1>&2
262    fi
263 }
264
265
266 mc() {
267    if test -n "$BASH_VERSION"; then
268       MC_SAVE_OPS1="$OPS1"
269       OPS1="\u@\h "
270    fi
271
272    if [ -n "$SLOWTERM" ]; then
273       MC_SLOW="--slow"
274    fi
275
276    case "$TERM" in
277       screen*) # screen, screen.rxvt
278          if [ "$TERM" = screen.rxvt ]; then
279             MC_SAVE_TERM="$TERM"
280             TERM=rxvt
281          fi
282          MC_XTERM="-x"
283       ;;
284    esac
285
286    #TMPDIR="$HOME"/tmp
287    #export TMPDIR
288
289    MC_FOUND=NO
290
291    for wrapper in \
292          /usr/local/share/mc/bin/mc-wrapper.sh \
293          /usr/local/libexec/mc/mc-wrapper.sh \
294          /usr/share/mc/bin/mc-wrapper.sh; do
295       if [ -r $wrapper ]; then
296          . $wrapper $MC_SLOW $MC_XTERM "$@"
297          rc=$?
298          MC_FOUND=YES
299          break
300       fi
301    done
302
303    if [ $MC_FOUND = NO ]; then
304       for mc in /usr/local/bin/mc /usr/bin/mc; do
305          if [ -x $mc ]; then
306             MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER"
307             if [ ! -d MC_TMP_DIR="${TMPDIR-/tmp}/mc-$USER" ]; then
308                MC_TMP_DIR="${TMPDIR-/tmp}"
309             fi
310             MC_PWD_FILE="$MC_TMP_DIR/mc.pwd.$$"
311             mc_type="`mc_type.py $mc`"
312             if [ "$mc_type" = old ]; then
313                $mc -P $MC_SLOW $MC_XTERM "$@" > "$MC_PWD_FILE"
314             elif [ "$mc_type" = new ]; then
315                $mc -P "$MC_PWD_FILE" $MC_SLOW $MC_XTERM "$@"
316             else
317                continue
318             fi
319             rc=$?
320             MC_FOUND=YES
321             cd "`cat \"$MC_PWD_FILE\"`" && /bin/rm "$MC_PWD_FILE"
322             break
323          fi
324       done
325    fi
326
327    if [ $MC_FOUND = NO ]; then
328       echo "Cannot find mc-wrapper.sh or mc" >&2
329       rc=1
330    fi
331
332    [ -n "$MC_SAVE_OPS1" ] && OPS1="$MC_SAVE_OPS1"
333    [ -n "$MC_SAVE_TERM" ] && TERM="$MC_SAVE_TERM"
334    unset MC_FOUND MC_PWD_FILE MC_SAVE_OPS1 MC_SAVE_TERM \
335          MC_SLOW MC_TMP_DIR MC_XTERM
336
337    return $rc
338 }
339
340
341 mkcd() {
342    if [ $# -ne 1 ]; then
343       echo "Usage: mkcd directory_name" >&2
344    elif [ -d "$1" ]; then
345       cd "$1"
346    elif [ -e "$1" ]; then
347       echo "Error: $1 is a file" >&2
348    else
349       mkdir -p "$1" && cd "$1"
350    fi
351 }
352
353
354 if which tmux >/dev/null 2>&1; then
355    tmux() {
356       case "$TERM" in
357          rxvt)
358             TERM=rxvt-unicode command tmux "$@"
359          ;;
360
361          *)
362             command tmux "$@"
363          ;;
364       esac
365    }
366 fi
367
368
369 if [ "$SHLVL" -eq 1 ] && which startx >/dev/null 2>&1; then
370    X() { startx >> .Xserver.log 2>&1; cyr; }
371 fi
372
373 x() { exit; }